> ## Documentation Index
> Fetch the complete documentation index at: https://developers.hubspot.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

---
id: 49dd3fcc-4f1f-4975-9e2c-95515e35da88
---

# Record attendance by participant email and HubSpot ID

> Records the participation of multiple HubSpot contacts in a Marketing Event using their email addresses.

If a contact does not exist, it will be automatically created. The contactProperties field is used exclusively for creating new contacts and will not update properties of existing contacts.

Additional Functionality:
- Adds a timeline event to the contacts.

Allowed Properties:
For the state "attend":
- joinedAt
- leftAt

> [accordion] Supported products

> [accordion] Required Scopes


## OpenAPI

````yaml specs/legacy/v3/marketing-marketing-events-v3.json POST /marketing/v3/marketing-events/{objectId}/attendance/{subscriberState}/email-create
openapi: 3.0.1
info:
  title: Marketing Marketing Events
  description: Basepom for all HubSpot Projects
  version: v3
  x-hubspot-product-tier-requirements:
    marketing: FREE
    sales: FREE
    service: FREE
    cms: FREE
    commerce: FREE
    crmHub: FREE
    dataHub: FREE
  x-hubspot-related-documentation:
    - name: Marketing Events Guide
      url: >-
        https://developers.hubspot.com/docs/guides/api/marketing/marketing-events
servers:
  - url: https://api.hubapi.com
security: []
tags:
  - name: Basic
  - name: Batch
  - name: Event Attendees
  - name: Event Status
  - name: Identifiers
  - name: List Associations
  - name: Participant State
  - name: Settings
  - name: Subscriber State Changes
paths:
  /marketing/v3/marketing-events/{objectId}/attendance/{subscriberState}/email-create:
    post:
      tags:
        - Event Attendees
      summary: Record Participants by Email with Marketing Event Object Id
      description: >-
        Records the participation of multiple HubSpot contacts in a Marketing
        Event using their email addresses.


        If a contact does not exist, it will be automatically created. The
        contactProperties field is used exclusively for creating new contacts
        and will not update properties of existing contacts.


        Additional Functionality:

        - Adds a timeline event to the contacts.


        Allowed Properties:

        For the state "attend":

        - joinedAt

        - leftAt
      operationId: >-
        post-/marketing/v3/marketing-events/{objectId}/attendance/{subscriberState}/email-create_recordByEmail
      parameters:
        - name: objectId
          in: path
          description: The internal id of the marketing event in HubSpot.
          required: true
          style: simple
          explode: false
          schema:
            type: string
        - name: subscriberState
          in: path
          description: >-
            The attendance state value. It may be 'register', 'attend' or
            'cancel'
          required: true
          style: simple
          explode: false
          schema:
            type: string
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/BatchInputMarketingEventEmailSubscriber'
        required: true
      responses:
        '200':
          description: successful operation
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/BatchResponseSubscriberEmailResponse'
        default:
          $ref: '#/components/responses/Error'
          description: ''
      security:
        - oauth2:
            - crm.objects.marketing_events.write
components:
  schemas:
    BatchInputMarketingEventEmailSubscriber:
      required:
        - inputs
      type: object
      properties:
        inputs:
          type: array
          description: List of marketing event details to create or update
          items:
            $ref: '#/components/schemas/MarketingEventEmailSubscriber'
    BatchResponseSubscriberEmailResponse:
      required:
        - completedAt
        - results
        - startedAt
        - status
      type: object
      properties:
        completedAt:
          type: string
          description: Timestamp that represents when the request finished processing
          format: date-time
        errors:
          type: array
          items:
            $ref: '#/components/schemas/StandardError'
        links:
          type: object
          additionalProperties:
            type: string
          description: Result of the request
        numErrors:
          type: integer
          description: The number of errors that occurred during the processing
          format: int32
        requestedAt:
          type: string
          description: Timestamp that represents when the request was made
          format: date-time
        results:
          type: array
          items:
            $ref: '#/components/schemas/SubscriberEmailResponse'
        startedAt:
          type: string
          description: Timestamp that represents when the request started processing
          format: date-time
        status:
          type: string
          description: The status of the request processing
          enum:
            - CANCELED
            - COMPLETE
            - PENDING
            - PROCESSING
    MarketingEventEmailSubscriber:
      required:
        - contactProperties
        - email
        - interactionDateTime
        - properties
      type: object
      properties:
        contactProperties:
          type: object
          additionalProperties:
            type: string
          description: The key-value set that contains properties of the contact.
        email:
          type: string
          description: >-
            The email address of the contact in HubSpot to associate with the
            event.
        interactionDateTime:
          type: integer
          description: >-
            Timestamp in milliseconds at which the contact subscribed to the
            event.
          format: int64
        properties:
          type: object
          additionalProperties:
            type: string
          description: The key-value set that contains properties of the marketing event.
    StandardError:
      required:
        - category
        - context
        - errors
        - links
        - message
        - status
      type: object
      properties:
        category:
          type: string
          description: The category of the error
        context:
          type: object
          additionalProperties:
            type: array
            items:
              type: string
          description: The object that contains details of the errors
        errors:
          type: array
          description: The detailed error objects.
          items:
            $ref: '#/components/schemas/ErrorDetail'
        id:
          type: string
          description: The ID of the request
        links:
          type: object
          additionalProperties:
            type: string
          description: Results of the request
        message:
          type: string
          description: >-
            A human readable message describing the error along with remediation
            steps where appropriate
        status:
          type: string
          description: Status of the response
        subCategory:
          type: object
          properties: {}
          description: The Sub-category of the error
      description: >-
        Represents a standard error response in the HubSpot API, providing
        detailed information about an error that occurred during an API request.
    SubscriberEmailResponse:
      required:
        - email
        - vid
      type: object
      properties:
        email:
          type: string
          description: The email of the contact
        vid:
          type: integer
          description: The internal ID of the contact
          format: int64
    Error:
      required:
        - category
        - correlationId
        - message
      type: object
      properties:
        category:
          type: string
          description: The error category
        context:
          type: object
          additionalProperties:
            type: array
            items:
              type: string
          description: Context about the error condition
          example: >-
            {invalidPropertyName=[propertyValue], missingScopes=[scope1,
            scope2]}
        correlationId:
          type: string
          description: >-
            A unique identifier for the request. Include this value with any
            error reports or support tickets
          format: uuid
          example: aeb5f871-7f07-4993-9211-075dc63e7cbf
        errors:
          type: array
          description: further information about the error
          items:
            $ref: '#/components/schemas/ErrorDetail'
        links:
          type: object
          additionalProperties:
            type: string
          description: >-
            A map of link names to associated URIs containing documentation
            about the error or recommended remediation steps
        message:
          type: string
          description: >-
            A human readable message describing the error along with remediation
            steps where appropriate
          example: An error occurred
        subCategory:
          type: string
          description: >-
            A specific category that contains more specific detail about the
            error
      description: >-
        Represents an error response returned by the API when an operation
        fails. This component is used in various endpoints to provide detailed
        information about the error encountered.
      example:
        message: Invalid input (details will vary based on the error)
        correlationId: aeb5f871-7f07-4993-9211-075dc63e7cbf
        category: VALIDATION_ERROR
        links:
          knowledge-base: https://www.hubspot.com/products/service/knowledge-base
    ErrorDetail:
      required:
        - message
      type: object
      properties:
        code:
          type: string
          description: The status code associated with the error detail
        context:
          type: object
          additionalProperties:
            type: array
            items:
              type: string
          description: Context about the error condition
          example: '{missingScopes=[scope1, scope2]}'
        in:
          type: string
          description: The name of the field or parameter in which the error was found.
        message:
          type: string
          description: >-
            A human readable message describing the error along with remediation
            steps where appropriate
        subCategory:
          type: string
          description: >-
            A specific category that contains more specific detail about the
            error
      description: >-
        Represents detailed information about an error that occurred in the API.
        This component is used to provide additional context and specifics about
        errors, typically as part of an error response.
  responses:
    Error:
      description: An error occurred.
      content:
        '*/*':
          schema:
            $ref: '#/components/schemas/Error'
  securitySchemes:
    oauth2:
      type: oauth2
      flows:
        authorizationCode:
          authorizationUrl: https://app.hubspot.com/oauth/authorize
          tokenUrl: https://api.hubapi.com/oauth/v1/token
          scopes:
            crm.objects.marketing_events.read: ''
            crm.objects.marketing_events.write: ''

````